local require = GLOBAL.require
local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS
local Recipe = GLOBAL.Recipe
local STRINGS = GLOBAL.STRINGS
local ACTIONS = GLOBAL.ACTIONS
local TECH = GLOBAL.TECH

PrefabFiles = {
	"yasuo",
        "woodsword",
        "trialsword",
        "bloodsword",
        "galesword",
        "galesword_low",
        "galecloak",
        "galegift",
        "hudun",
        "fengqiang",
        "yasuo_huanyuan",
        "yasuo_fangyu",
        "yasuo_gongji",
}


Assets = {
    Asset( "IMAGE", "images/saveslot_portraits/yasuo.tex" ),
    Asset( "ATLAS", "images/saveslot_portraits/yasuo.xml" ),

    Asset( "IMAGE", "images/selectscreen_portraits/yasuo.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/yasuo.xml" ),

    Asset( "IMAGE", "bigportraits/yasuo.tex" ),
    Asset( "ATLAS", "bigportraits/yasuo.xml" ),
    
    Asset( "IMAGE", "images/map_icons/yasuo.tex" ),
    Asset( "ATLAS", "images/map_icons/yasuo.xml" ),
    	
    Asset( "IMAGE", "images/avatars/avatar_yasuo.tex" ),
    Asset( "ATLAS", "images/avatars/avatar_yasuo.xml" ),

    Asset("IMAGE", "images/yasuotabs/yasuotab.tex"),
    Asset("ATLAS", "images/yasuotabs/yasuotab.xml"),

    Asset("IMAGE", "images/inventoryimages/woodsword.tex"),
    Asset("ATLAS", "images/inventoryimages/woodsword.xml"),

    Asset("IMAGE", "images/inventoryimages/trialsword.tex"),
    Asset("ATLAS", "images/inventoryimages/trialsword.xml"),
    
    Asset("IMAGE", "images/inventoryimages/bloodsword.tex"),
    Asset("ATLAS", "images/inventoryimages/bloodsword.xml"),

    Asset("IMAGE", "images/inventoryimages/galesword.tex"),
    Asset("ATLAS", "images/inventoryimages/galesword.xml"),

    Asset("IMAGE", "images/inventoryimages/galesword_low.tex"),
    Asset("ATLAS", "images/inventoryimages/galesword_low.xml"),

    Asset("IMAGE", "images/inventoryimages/galecloak.tex"),
    Asset("ATLAS", "images/inventoryimages/galecloak.xml"),

    Asset("IMAGE", "images/inventoryimages/galegift.tex"),
    Asset("ATLAS", "images/inventoryimages/galegift.xml"),

    Asset("SOUNDPACKAGE", "sound/yasuo_sound.fev"),
    Asset("SOUND", "sound/yasuo_sound.fsb"),
}


GLOBAL.STRINGS.NAMES.WOODSWORD = "WoodSword"
GLOBAL.STRINGS.RECIPE_DESC.WOODSWORD = "A legendary sword!"
GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.WOODSWORD = "WoodSword"

GLOBAL.STRINGS.NAMES.TRIALSWORD = "TrialSword"
GLOBAL.STRINGS.RECIPE_DESC.TRIALSWORD = "A mysterious sword!"
GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.TRIALSWORD = "TrialSword"

GLOBAL.STRINGS.NAMES.BLOODSWORD = "Bloodsword"
GLOBAL.STRINGS.RECIPE_DESC.BLOODSWORD = "My sword is Hungry!"
GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.BLOODSWORD = "Bloodsword"

GLOBAL.STRINGS.NAMES.GALESWORD_LOW = "Galesword_Low"
GLOBAL.STRINGS.RECIPE_DESC.GALESWORD_LOW = "Can't destroy structure!"
GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.GALESWORD_LOW = "Galesword_Low"

GLOBAL.STRINGS.NAMES.GALESWORD = "Galesword"
GLOBAL.STRINGS.RECIPE_DESC.GALESWORD = "Gale can destroy anything!"
GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.GALESWORD = "Galesword"

GLOBAL.STRINGS.NAMES.GALECLOAK = "Galecloak"
GLOBAL.STRINGS.RECIPE_DESC.GALECLOAK = "Invisible Wind!"
GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.GALECLOAK = "Galecloak"

GLOBAL.STRINGS.NAMES.GALEGIFT = "Galegift"
GLOBAL.STRINGS.RECIPE_DESC.GALEGIFT = "Wind Protection!"
GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.GALEGIFT = "Galegift"

GLOBAL.STRINGS.CHARACTER_TITLES.yasuo = "Yasuo"
GLOBAL.STRINGS.CHARACTER_NAMES.yasuo = "Yasuo"
GLOBAL.STRINGS.CHARACTER_DESCRIPTIONS.yasuo = "*Fast-but-easy-to-die \n*An-amazing-sword\n*Sword-can-be-hided"
GLOBAL.STRINGS.CHARACTER_QUOTES.yasuo = "\"Death is like the wind; always by my side\""


function yasuoPostInit(yasuo)
    local woodsword = Recipe("woodsword", {Ingredient("log", 3)}, RECIPETABS.YASUOTAB, {SCIENCE = 0})
    woodsword.atlas = "images/inventoryimages/woodsword.xml"

    local woodsword = Ingredient( "woodsword", 1)
    woodsword.atlas = "images/inventoryimages/woodsword.xml"

    local bloodsword = Recipe("bloodsword", {woodsword, Ingredient("monstermeat", 3)}, RECIPETABS.YASUOTAB, {SCIENCE = 0})
    bloodsword.atlas = "images/inventoryimages/bloodsword.xml"

    local trialsword = Recipe("trialsword", {woodsword, Ingredient("goldnugget", 3)}, RECIPETABS.YASUOTAB, {SCIENCE = 0})
    trialsword.atlas = "images/inventoryimages/trialsword.xml"

    local trialsword = Ingredient( "trialsword", 1)
    trialsword.atlas = "images/inventoryimages/trialsword.xml"

    local galesword_low = Recipe("galesword_low", {trialsword, Ingredient("livinglog", 3)}, RECIPETABS.YASUOTAB, {SCIENCE = 0})
    galesword_low.atlas = "images/inventoryimages/galesword_low.xml"

    local galesword_low = Ingredient( "galesword_low", 1)
    galesword_low.atlas = "images/inventoryimages/galesword_low.xml"

    local galesword = Recipe("galesword", {galesword_low, Ingredient("monstermeat", 3)}, RECIPETABS.YASUOTAB, {SCIENCE = 0})
    galesword.atlas = "images/inventoryimages/galesword.xml"

    local galecloak = Recipe("galecloak", {Ingredient("pigskin", 1), Ingredient("rope", 3), Ingredient("livinglog", 3)}, RECIPETABS.YASUOTAB, {SCIENCE = 0})
    galecloak.atlas = "images/inventoryimages/galecloak.xml"

    local galegift = Recipe("galegift", {Ingredient("flowerhat", 1), Ingredient("livinglog", 3)}, RECIPETABS.YASUOTAB, {SCIENCE = 0})
    galegift.atlas = "images/inventoryimages/galegift.xml"

end




function AddMap(inst)
    local minimap = inst.entity:AddMiniMapEntity()
    minimap:SetIcon( inst.prefab .. ".tex" )
end
AddPrefabPostInit("woodsword", AddMap)
AddMinimapAtlas("images/inventoryimages/woodsword.xml")
AddPrefabPostInit("trialsword", AddMap)
AddMinimapAtlas("images/inventoryimages/trialsword.xml")
AddPrefabPostInit("bloodsword", AddMap)
AddMinimapAtlas("images/inventoryimages/bloodsword.xml")
AddPrefabPostInit("galesword", AddMap)
AddMinimapAtlas("images/inventoryimages/galesword.xml")
AddPrefabPostInit("galecloak", AddMap)
AddMinimapAtlas("images/inventoryimages/galecloak.xml")
AddPrefabPostInit("galegift", AddMap)
AddMinimapAtlas("images/inventoryimages/galegift.xml")

table.insert(GLOBAL.CHARACTER_GENDERS.MALE, "yasuo")
AddMinimapAtlas("images/map_icons/yasuo.xml")
AddModCharacter("yasuo")

AddSimPostInit(function(inst)
        if inst.prefab == "yasuo" then
               yasuoPostInit(inst)
        end
end)


local attack_name = {"bee", "killerbee", "flies", "mosquito", "frog", "beefalo", "lightninggoat", "pigman", "pigguard",
 "bunnyman", "catcoon", "merm", "spider_hider", "spider_spitter", "spider", "spider_warrior", "spiderqueen", "spider_dropper", "hound",
 "firehound", "icehound", "tentacle", "leif", "leif_sparse", "walrus", "teenbird", "tallbird", "koalefant_summer",
 "koalefant_winDter", "penguin", "slurtle", "snurtle", "bat", "rocky", "monkey", "slurper", "buzzard", "knight", "bishop",
 "rook", "crawlinghorror", "terrorbeak", "deerclops", "minotaur", "worm", "abigail", "ghost", "shadowwaxwell", "krampus",
 "glommer", "lureplant", "eyeplant", "moose", "mossling", "dragonfly", "warg", "bearger", "birchnutdrake"
}


--每20s可以免疫一次伤害
local GetPlayer = GLOBAL.GetPlayer
local cooldowntime = 20
local cooldown
local function onattack(inst, data)
    if  data.target.prefab == "yasuo"
    and not cooldown then
    cooldown = true
    inst.components.combat:SetDefaultDamage(0)

    local hudun = GLOBAL.SpawnPrefab("hudun")
    hudun.entity:SetParent(GetPlayer().entity)
    hudun.Transform:SetPosition(0, 0, 0)
    hudun.Transform:SetScale(2, 2, 2)
    hudun.AnimState:PlayAnimation("idle_hd",true)
    GetPlayer():DoTaskInTime( 0.6, function() 
    	hudun.kill_fx(hudun) 
        if inst.task then inst.task:Cancel() inst.task = nil end 
    end)

    local light = GetPlayer().entity:AddLight()
    light:SetFalloff(0.8)
    light:SetIntensity(0.5)
    light:SetRadius(0.8)
    light:SetColour(255/255, 255/255, 255/255)
    light:Enable(true)

    GetPlayer():DoTaskInTime( cooldowntime, function() 
      cooldown = false
      light:Enable(false)
      end)

    else
    inst.components.combat:SetDefaultDamage(inst.components.combat.tempdamage)
    end
end
--技能基础函数
local function dodge(inst)
    if GetPlayer().prefab == "yasuo"
        and inst.components.combat then
        inst.components.combat.tempdamage = inst.components.combat.defaultdamage
        inst:ListenForEvent("onattackother", onattack)
    end
end

--为列表上的生物攻击变为0

for k,v in pairs(attack_name) do
    AddPrefabPostInit (v, dodge)
end