local assets=
{
    Asset("ANIM", "anim/galecloak.zip"),
    Asset("ANIM", "anim/swap_galecloak.zip"),
    Asset("ATLAS", "images/inventoryimages/galecloak.xml"), 
    Asset("IMAGE", "images/inventoryimages/galecloak.tex"),
}

local function galecloak_pro(owner, data)
    local absorb_plus = 0.35
    if  not owner.cooldown then
        if  math.random() < 0.25 then
            owner.cooldown = true
            local absorb_present = owner.components.health.absorb
            owner.components.health.absorb = absorb_present + absorb_plus
            owner.components.talker:Say("Wind is motionless")
            owner:DoTaskInTime(3, function() 
                owner.cooldown = false
                owner.components.health.absorb = absorb_present
            end)
        end
    end
end

local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_body", "swap_galecloak", "backpack")
    owner.AnimState:OverrideSymbol("swap_body", "swap_galecloak", "swap_body")
    owner.components.inventory:SetOverflow(inst)
    inst.components.container:Open(owner)
    inst:ListenForEvent("attacked", galecloak_pro, owner)
end

local function onunequip(inst, owner) 
    owner.AnimState:ClearOverrideSymbol("swap_body")
    owner.AnimState:ClearOverrideSymbol("backpack")
    owner.components.inventory:SetOverflow(nil)
    inst.components.container:Close(owner)
    inst:RemoveEventCallback("attacked", galecloak_pro, owner)
end
--[[
local function ondropped(inst)
    inst.AnimState:PlayAnimation("anim")
end
]]
local function gcPercentChanged(inst, data)
    if inst.components.armor.condition < 999999 then
        inst.components.armor.condition = 999999
    end
end

local slotpos = {}
for y = 0, 3 do
    table.insert(slotpos, Vector3(-162, -y*75 + 114 ,0))
    table.insert(slotpos, Vector3(-162 +75, -y*75 + 114 ,0))
end

local function fn(Sim)
    local inst = CreateEntity()
    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.AnimState:SetBank("galecloak")
    inst.AnimState:SetBuild("swap_galecloak")
    inst.AnimState:PlayAnimation("anim")
    MakeInventoryPhysics(inst)
    inst.entity:AddTransform():SetScale(1.75, 1.75, 1.75)

    inst.entity:AddMiniMapEntity()
    inst.MiniMapEntity:SetIcon("galecloak.tex")

    inst:AddComponent("inspectable")
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.cangoincontainer = true
    inst.components.inventoryitem.imagename = "galecloak"
    --inst.components.inventoryitem:SetOnDroppedFn(ondropped)
    inst.components.inventoryitem.atlasname = "images/inventoryimages/galecloak.xml"
    inst.components.inventoryitem.foleysound = "dontstarve/movement/foley/krampuspack"

    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.BODY    
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )

    --防风，效果相当于海难防风衣（海难）
    if not IsDLCEnabled(REIGN_OF_GIANTS) then
        MakeInventoryFloatable(inst, "idle_water", "anim")
        inst:AddComponent("windproofer")
        inst.components.windproofer:SetEffectiveness(1)
    end
    
    --防暑，效果相当于草帽
    inst:AddComponent("insulator")
    inst.components.insulator:SetSummer()
    inst.components.insulator:SetInsulation(60)
    
    --防雨，效果相当于小花伞
    inst:AddComponent("waterproofer")
    inst.components.waterproofer:SetEffectiveness(0.2)

    --移动速度上升0.05 
    inst.components.equippable.walkspeedmult = 1.05

    --承受伤害上升0.1（防御力下降0.1）
    inst:AddComponent("armor")
    inst.components.armor:InitCondition(999999, -0.1)
    inst:ListenForEvent("percentusedchange", gcPercentChanged)

    inst:AddComponent("container")
    inst.components.container:SetNumSlots(#slotpos)
    inst.components.container.widgetslotpos = slotpos
    inst.components.container.widgetanimbank = "ui_backpack_2x4"
    inst.components.container.widgetanimbuild = "ui_backpack_2x4"
    inst.components.container.widgetpos = Vector3(-5,-70,0)
    inst.components.container.side_widget = true
    inst.components.container.type = "pack"
   
    inst.components.container.onopenfn = function(inst) GetPlayer().SoundEmitter:PlaySound("dontstarve/wilson/backpack_open") end
    inst.components.container.onclosefn = function(inst) GetPlayer().SoundEmitter:PlaySound("dontstarve/wilson/backpack_close") end
    
    return inst
end

return Prefab( "common/inventory/galecloak", fn, assets) 
