local assets=
{
	Asset("ANIM", "anim/galegift.zip"),
	Asset("ATLAS", "images/inventoryimages/galegift.xml")
}

local function galegift_pro(owner, data)
    local speed_plus = 1.35	
    if  not owner.cooldown then
		if 	math.random() < 0.25 then
			owner.cooldown = true
    		local walkspeed_present = owner.components.locomotor.walkspeed
    		owner.components.locomotor.walkspeed = walkspeed_present * speed_plus
    		local runspeed_present = owner.components.locomotor.runspeed
    		owner.components.locomotor.runspeed = runspeed_present * speed_plus
    		owner.components.talker:Say("Wind is coming")
			owner:DoTaskInTime(1, function() 
				owner.components.locomotor.walkspeed = walkspeed_present
				owner.components.locomotor.runspeed = runspeed_present
				owner.cooldown = false
			end)
		end
	end
end

local function onequip(inst, owner) 
	inst:ListenForEvent("attacked", galegift_pro, owner)
end

local function onunequip(inst, owner) 
	inst:RemoveEventCallback("attacked", galegift_pro, owner)
end

local function ondrop(inst)

end



local function gcPercentChanged(inst, data)
    if inst.components.armor.condition < 999999 then
        inst.components.armor.condition = 999999
    end
end

local function fn(Sim)
    local inst = CreateEntity()
    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.AnimState:SetBank("galegift")
    inst.AnimState:SetBuild("galegift")
    inst.AnimState:PlayAnimation("idel")
    MakeInventoryPhysics(inst)

    inst:AddComponent("inspectable")
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/galegift.xml"
	inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.HEAD

    --精神恢复等同于花环
    inst.components.equippable.dapperness = 100/(480*5)

    --防风，效果相当于海难防风衣（海难）
    if not IsDLCEnabled(REIGN_OF_GIANTS) then
        inst:AddComponent("windproofer")
        inst.components.windproofer:SetEffectiveness(1)
    end

    --防暑，效果相当于草帽
    inst:AddComponent("insulator")
    inst.components.insulator:SetSummer()
    inst.components.insulator:SetInsulation(60)

    --移动速度上升0.1 
    inst.components.equippable.walkspeedmult = 1.05

    --承受伤害上升0.1（防御力下降0.1）
    inst:AddComponent("armor")
    inst.components.armor:InitCondition(999999, -0.1)
    inst:ListenForEvent("percentusedchange", gcPercentChanged)

    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)
	inst.components.inventoryitem:SetOnDroppedFn( ondrop )


	return inst
end
return Prefab( "common/inventory/galegift", fn, assets)

