require("recipe")

local MakePlayerCharacter = require "prefabs/player_common"
local assets = {

        Asset( "ANIM", "anim/player_basic.zip" ),
        Asset( "ANIM", "anim/player_idles_shiver.zip" ),
        Asset( "ANIM", "anim/player_actions.zip" ),
        Asset( "ANIM", "anim/player_actions_axe.zip" ),
        Asset( "ANIM", "anim/player_actions_pickaxe.zip" ),
        Asset( "ANIM", "anim/player_actions_shovel.zip" ),
        Asset( "ANIM", "anim/player_actions_blowdart.zip" ),
        Asset( "ANIM", "anim/player_actions_eat.zip" ),
        Asset( "ANIM", "anim/player_actions_item.zip" ),
        Asset( "ANIM", "anim/player_actions_uniqueitem.zip" ),
        Asset( "ANIM", "anim/player_actions_bugnet.zip" ),
        Asset( "ANIM", "anim/player_actions_fishing.zip" ),
        Asset( "ANIM", "anim/player_actions_boomerang.zip" ),
        Asset( "ANIM", "anim/player_bush_hat.zip" ),
        Asset( "ANIM", "anim/player_attacks.zip" ),
        Asset( "ANIM", "anim/player_idles.zip" ),
        Asset( "ANIM", "anim/player_rebirth.zip" ),
        Asset( "ANIM", "anim/player_jump.zip" ),
        Asset( "ANIM", "anim/player_amulet_resurrect.zip" ),
        Asset( "ANIM", "anim/player_teleport.zip" ),
        Asset( "ANIM", "anim/wilson_fx.zip" ),
        Asset( "ANIM", "anim/player_one_man_band.zip" ),
        Asset( "ANIM", "anim/shadow_hands.zip" ),
        Asset( "SOUND", "sound/sfx.fsb" ),
        Asset( "SOUND", "sound/wilson.fsb" ),
        Asset( "ANIM", "anim/beard.zip" ),

        Asset( "ANIM", "anim/yasuo.zip" ),
        Asset( "ANIM", "anim/yasuo_fy.zip" ),
        Asset( "ANIM", "anim/yasuo_gj.zip" ),
        Asset( "IMAGE", "images/yasuotabs/yasuotab.tex"),
        Asset( "ATLAS", "images/yasuotabs/yasuotab.xml"),
}
local prefabs = {}

local start_inv =
{
        "livinglog",
        "livinglog",
        "livinglog",
        "woodsword",
}

local max_upgrades = 15
local function applyupgrades(inst)

    local upgrades = math.min(inst.level, max_upgrades)

    local hunger_percent = inst.components.hunger:GetPercent()
    local health_percent = inst.components.health:GetPercent()
    local sanity_percent = inst.components.sanity:GetPercent()

    inst.components.hunger.max = math.ceil (90 + upgrades * 4)
    inst.components.health.maxhealth = math.ceil (60 + upgrades * 2)
    inst.components.sanity.max = math.ceil (90 + upgrades * 2)
    inst.components.locomotor.walkspeed =  math.ceil (4 * (upgrades/100+1.05))
    inst.components.locomotor.runspeed = math.ceil (6 * (upgrades/100+1.05))        
    if inst.components.combat.attack_damage_modifiers then
        inst.components.combat.attack_damage_modifiers[1] = (upgrades/100*4/3)
    else
        inst.components.combat.damagemultiplier = (1 * (upgrades/100*2+0.9))
    end
    inst.components.talker:Say("Wind Up! : ".. (inst.level)) 
    if inst.level > 14 then
        inst.components.talker:Say("Wind : Max!")
    end
    --inst.components.health:SetAbsorptionAmount(1)
--3级回复生命值
    if inst.level > 2 then
        inst.components.health:StartRegen((60 + upgrades * 4)*0.1/16, 30) 
    end
--5级回复精神值
    if inst.level > 4 then        
        TUNING.SANITY_DAY_GAIN=(60 + upgrades * 4)*0.1/480--100/(day_time*32),
        TUNING.SANITY_NIGHT_LIGHT=-100/(60*20)+(60 + upgrades * 4)*0.1/480
        TUNING.SANITY_NIGHT_MID=-100/(60*20)+(60 + upgrades * 4)*0.1/480
        TUNING.SANITY_NIGHT_DARK=-100/(60*2)+(60 + upgrades * 4)*0.1/480
    end

    inst.components.hunger:SetPercent(hunger_percent)
    inst.components.health:SetPercent(health_percent)
    inst.components.sanity:SetPercent(sanity_percent)

--状态1：初始状态
    TheInput:AddKeyDownHandler(KEY_Z, function()

            inst.AnimState:SetBuild("yasuo")
            inst.components.locomotor.walkspeed =  math.ceil (4 * (upgrades/100+1.05))
            inst.components.locomotor.runspeed = math.ceil (6 * (upgrades/100+1.05)) 
            inst.components.health.absorb = 0
            local player = GetPlayer()
            local huanyuan = SpawnPrefab("yasuo_huanyuan")
            huanyuan.entity:SetParent(player.entity)
            huanyuan.Transform:SetPosition(0, 0.2, 0)
            huanyuan.Transform:SetScale(0.75,0.75, 0.75)
            huanyuan.AnimState:PlayAnimation("action_hy",true)
            player:DoTaskInTime(0.6, function()
                huanyuan.kill_fx(huanyuan) 
                if inst.task then inst.task:Cancel() inst.task = nil end 
            end)

            if inst.components.combat.attack_damage_modifiers then
                inst.components.combat.attack_damage_modifiers[1] = (upgrades/100*4/3-0.1)
            else
                inst.components.combat.damagemultiplier = (1 * (upgrades/100*2+0.9))
            end
            TUNING.SANITY_DAY_GAIN=(60 + upgrades * 4)*0.1/480--100/(day_time*32),        
            TUNING.SANITY_NIGHT_LIGHT=-100/(60*20)+(60 + upgrades * 4)*0.1/480
            TUNING.SANITY_NIGHT_MID=-100/(60*20)+(60 + upgrades * 4)*0.1/480
            TUNING.SANITY_NIGHT_DARK=-100/(60*2)+(60 + upgrades * 4)*0.1/480
            inst.components.hunger:SetRate(75/480)--75/480s（每天下降75饥饿）

    end)

--状态2：5级后，每秒消耗1饥饿值，攻击上升0.2，移动速度下降0.1，承受伤害降低0.4
    TheInput:AddKeyDownHandler(KEY_X, function()
    if inst.level > 4 then 
            inst.AnimState:SetBuild("yasuo_fy")
            inst.components.locomotor.walkspeed =  math.ceil (4 * (upgrades/100+0.9))
            inst.components.locomotor.runspeed = math.ceil (6 * (upgrades/100+0.9)) 
            inst.components.health.absorb = 0.4

            local player = GetPlayer()
            local fangyu = SpawnPrefab("yasuo_fangyu")
            fangyu.entity:SetParent(player.entity)
            fangyu.Transform:SetPosition(0, 0.2, 0)
            fangyu.Transform:SetScale(0.75,0.75, 0.75)
            fangyu.AnimState:PlayAnimation("action_fy",true)
            player:DoTaskInTime(0.6, function()
                fangyu.kill_fx(fangyu) 
                if inst.task then inst.task:Cancel() inst.task = nil end 
            end)

            if inst.components.combat.attack_damage_modifiers then
               inst.components.combat.attack_damage_modifiers[1] = (upgrades/100*4/3+0.1)
            else
                inst.components.combat.damagemultiplier = (1 * (upgrades/100*2+1.1))
            end
            TUNING.SANITY_DAY_GAIN=(60 + upgrades * 4)*0.1/480--100/(day_time*32),        
            TUNING.SANITY_NIGHT_LIGHT=-100/(60*20)+(60 + upgrades * 4)*0.1/480
            TUNING.SANITY_NIGHT_MID=-100/(60*20)+(60 + upgrades * 4)*0.1/480
            TUNING.SANITY_NIGHT_DARK=-100/(60*2)+(60 + upgrades * 4)*0.1/480
            inst.components.hunger:SetRate(1)

    else
        inst.components.talker:Say("I need level-5!")
    end
    end)

--状态3：10级后，每秒消耗1精神值，攻击上升0.2，移动速度上升0.1，承受伤害上升0.2
    TheInput:AddKeyDownHandler(KEY_C, function()
    if inst.level > 9 then 
        inst.AnimState:SetBuild("yasuo_gj")
        inst.components.locomotor.walkspeed =  math.ceil (4 * (upgrades/100+1.20))
        inst.components.locomotor.runspeed = math.ceil (6 * (upgrades/100+1.20)) 
        inst.components.health.absorb = -0.2

        local player = GetPlayer()
        local gongji = SpawnPrefab("yasuo_gongji")
        gongji.entity:SetParent(player.entity)
        gongji.Transform:SetPosition(0, 0.2, 0)
        gongji.Transform:SetScale(0.75,0.75, 0.75)
        gongji.AnimState:PlayAnimation("action_gj",true)
        player:DoTaskInTime(0.6, function()
            gongji.kill_fx(gongji) 
            if inst.task then inst.task:Cancel() inst.task = nil end 
        end)

        if inst.components.combat.attack_damage_modifiers then
            inst.components.combat.attack_damage_modifiers[1] = (upgrades/100*4/3+0.1)
        else
            inst.components.combat.damagemultiplier = (1 * (upgrades/100*2+1.1))
        end
        TUNING.SANITY_DAY_GAIN=-1--100/(day_time*32),        
        TUNING.SANITY_NIGHT_LIGHT=-100/(60*20)-1
        TUNING.SANITY_NIGHT_MID=-100/(60*20)-1
        TUNING.SANITY_NIGHT_DARK=-100/(60*2)-1
        inst.components.hunger:SetRate(75/480)--75/480s（每天下降75饥饿）

    else
        inst.components.talker:Say("I need level-10!")
    end
    end)

--风墙：5级后，以自身为中心，瞬间击退生物，接下来一定时间内（基于等级2.5-5s）伤害免疫，消耗10san
    TheInput:AddKeyUpHandler(KEY_V, function()
    if inst.level > 4 then 
    if not  IsPaused() and not TheInput:IsKeyDown(KEY_CTRL) and not TheInput:IsKeyDown(KEY_SHIFT) then
        if  inst.components.sanity.current < 20 then
            GetPlayer().components.talker:Say("I'm too stupid")
        else 
--        if not inst.fengqiang then
--            inst.fengqiang = false 
            inst.components.sanity:DoDelta(-10)           --精神消耗10san
            local player = GetPlayer()
            local pt = Vector3(player.Transform:GetWorldPosition())
            GetPlayer().components.talker:Say("Face the wind!") 
            
            --SpawnPrefab("firering_fx").Transform:SetPosition(pt.x, pt.y, pt.z)
            local fengqiang = SpawnPrefab("fengqiang")
            fengqiang.entity:SetParent(player.entity)
            fengqiang.Transform:SetPosition(0, 0.8, 0)
            fengqiang.Transform:SetScale(2, 2, 2)
            fengqiang.AnimState:PlayAnimation("idle_fq",true)
            --inst.entity:AddSoundEmitter(60)
            --inst.SoundEmitter:PlaySound("yasuo_sound/skill/fengqiang")
            player:DoTaskInTime(0.6, function()
                fengqiang.kill_fx(fengqiang) 
                if inst.task then inst.task:Cancel() inst.task = nil end 
            end)

            local pos = Vector3(player.Transform:GetWorldPosition())
            local ents = TheSim:FindEntities(pos.x,pos.y,pos.z, 5)
            for k,v in pairs(ents) do
                if v.components.health and v.components.combat and not v.components.health:IsDead() and not v:HasTag("player") and not v:HasTag("wall") and not v:HasTag("hive") then  
                    local pt1 = player:GetPosition()
                    local pt2 = v:GetPosition()
                    local fqradius = 5                    --风墙击退半径
                    local fqxdirection = math.abs(pt2.x-pt1.x)
                    local fqzdirection = math.abs(pt2.z-pt1.z)
                    v.Transform:SetPosition((pt2.x-pt1.x)/fqxdirection*(fqradius-fqxdirection)+pt2.x, 0, (pt2.z-pt1.z)/fqzdirection*(fqradius-fqzdirection)+pt2.z)
                end
            end
            local huduntime = math.min(upgrades/2, 5)    --伤害免疫（基于等级<=5s）
            inst.components.health.absorb = 1.00
            GetPlayer():DoTaskInTime( huduntime, function() 
                inst.components.health.absorb = 0
            end)

 --[[           
            player:DoTaskInTime(5, function() 
                inst.fengqiang = false 
            end) 
        else
            GetPlayer().components.talker:Say(" It is on CD  !")     
        end]]
        end
    end
    else
        inst.components.talker:Say("I need level-5!")
    end
    end)
end

local function onkill(inst, data)
    local iflevelup = false
    local xpbar = 5*(inst.level+1)
    if data.cause == inst.prefab and not data.inst:HasTag("companion") then
        if  data.inst:HasTag("moose") 
            or data.inst:HasTag("dragonfly")
            or data.inst:HasTag("bearger")
            or data.inst:HasTag("deerclops") 
            then
            iflevelup = true
        elseif 
            not data.inst:HasTag("insect") 
            and not data.inst:HasTag("eyeplant") 
            then
            inst.xpnow = inst.xpnow + 1
        end
    end

    if inst.xpnow >= 5*(inst.level + 1) then
        iflevelup =true
    end

    if iflevelup and inst.level < max_upgrades then
        inst.level = inst.level + 1
        inst.xpnow = 0
        applyupgrades(inst) 

        inst.components.sanity:DoDelta(inst.components.sanity.max*0.2)
        inst.components.health:DoDelta(inst.components.health.maxhealth*0.15)
        inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")

        inst.HUD.controls.status.heart:PulseGreen()
        inst.HUD.controls.status.stomach:PulseGreen()
        inst.HUD.controls.status.brain:PulseGreen()

        inst.HUD.controls.status.brain:ScaleTo(1.3,1,.7)
        inst.HUD.controls.status.heart:ScaleTo(1.3,1,.7)
        inst.HUD.controls.status.stomach:ScaleTo(1.3,1,.7)
    end

end


local function onpreload(inst, data)
    if data then
        if data.level then
            inst.level = data.level
            applyupgrades(inst)
            --reset these from the save data, because of load-order clipping issues
            if data.health and data.health.health then inst.components.health.currenthealth = data.health.health end
            if data.hunger and data.hunger.hunger then inst.components.hunger.current = data.hunger.hunger end
            if data.sanity and data.sanity.current then inst.components.sanity.current = data.sanity.current end
            inst.components.health:DoDelta(0)
            inst.components.hunger:DoDelta(0)
            inst.components.sanity:DoDelta(0)
        end
       
        if  data.xpnow then
            inst.xpnow = data.xpnow
            onkill(inst, data)
        end
     
    end
end

local function onsave(inst, data)
    data.level = inst.level
    data.xpnow = inst.xpnow
end

local fn = function(inst)
    RECIPETABS['YASUOTAB'] = {str = "YASUOTAB", sort=999, icon = "yasuotab.tex", icon_atlas = "images/yasuotabs/yasuotab.xml"}
    inst.Transform:SetScale(1.1,1.1,1.1)
    
    inst.soundsname = "wilson"
    inst.MiniMapEntity:SetIcon( "yasuo.tex" )
    inst.level = 0
    inst.xpnow = 0
    inst.transformed = true
    applyupgrades(inst)

    -- Damage multiplier (optional)
    inst.components.combat.damagemultiplier = 0.9
    
    -- Movement speed (optional)
    inst.components.locomotor.walkspeed = 4.2
    inst.components.locomotor.runspeed = 6.3

    inst.OnSave = onsave
    inst.OnPreLoad = onpreload

    -- lower profit from non-meat food

    inst:ListenForEvent("entity_death", function(wrld, data) onkill(inst, data) end, GetWorld())

    TheInput:AddKeyDownHandler(KEY_L, function()
    if  inst.level < max_upgrades then
        inst.components.talker:Say("EXP  "..(inst.xpnow).."/"..(5*(inst.level + 1)))
    else
        inst.components.talker:Say("Wind : Max!")
    end
    end)

end


return MakePlayerCharacter("yasuo", prefabs, assets, fn, start_inv)
